"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
var tslib_1 = require("tslib");
var react_1 = tslib_1.__importDefault(require("react"));
var Item_1 = require("./Item");
var helper_1 = require("../../utils/helper");
var CompositionControl = /** @class */ (function (_super) {
    tslib_1.__extends(CompositionControl, _super);
    function CompositionControl() {
        return _super !== null && _super.apply(this, arguments) || this;
    }
    CompositionControl.prototype.handleChange = function (value) {
        var onChange = this.props.onChange;
        onChange && onChange(value);
    };
    CompositionControl.prototype.renderMain = function () {
        var _a = this.props, name = _a.name, mainType = _a.mainType, render = _a.render;
        var mainSchema = {
            type: 'control',
            control: tslib_1.__assign(tslib_1.__assign({}, mainType), { name: name, label: false })
        };
        return render('', mainSchema, { onChange: this.handleChange });
    };
    CompositionControl.prototype.renderSub = function () {
        var _a = this.props, condition = _a.condition, subType = _a.subType, render = _a.render;
        var subSchema = {
            type: 'control',
            control: tslib_1.__assign(tslib_1.__assign({}, subType), { 
                // name: 'danger',
                visibleOn: condition, label: false })
        };
        return render('', subSchema);
    };
    CompositionControl.prototype.render = function () {
        return (react_1.default.createElement(react_1.default.Fragment, null,
            this.renderMain(),
            this.renderSub()));
    };
    tslib_1.__decorate([
        helper_1.autobind,
        tslib_1.__metadata("design:type", Function),
        tslib_1.__metadata("design:paramtypes", [Object]),
        tslib_1.__metadata("design:returntype", void 0)
    ], CompositionControl.prototype, "handleChange", null);
    return CompositionControl;
}(react_1.default.Component));
exports.default = CompositionControl;
var CompositionControlRenderer = /** @class */ (function (_super) {
    tslib_1.__extends(CompositionControlRenderer, _super);
    function CompositionControlRenderer() {
        return _super !== null && _super.apply(this, arguments) || this;
    }
    CompositionControlRenderer = tslib_1.__decorate([
        Item_1.FormItem({
            type: 'composition'
        })
    ], CompositionControlRenderer);
    return CompositionControlRenderer;
}(CompositionControl));
exports.CompositionControlRenderer = CompositionControlRenderer;
//# sourceMappingURL=./renderers/Form/Composition.js.map
